if(isPackage(mNameTagging))
   deActivatePackage(mNameTagging);
package mNameTagging
{
   function clientcmdChatMessage(%client,%b,%c,%fmsg,%pref,%name,%suff,%msg)
   {
      %mTag = mTagging_GetTag(%client,%name);
      %fmsg = getword(%fmsg,0) SPC %mTag@"\c7"@%pref@"\c3"@%name@"\c7"@%suff@"\c6: "@%msg;
      parent::clientcmdChatMessage(%client,%b,%c,%fmsg,%pref,%name,%suff,%msg);
   }
   function NewPlayerListGui::update(%obj,%client,%name,%bl_id,%a,%b,%c)
   {
      Parent::update(%obj,%client,%name,%bl_id,%a,%b,%c);
      %k=NewPlayerListGui.isAwake();
      if(%k)
         canvas.popdialog(NewPlayerListGui);
      canvas.pushdialog(NewPlayerListGui);
      if(!%k)
         canvas.popdialog(NewPlayerListGui);
      $mTagging::StoredClient[%client]=%bl_id TAB %name;
      mTagging_StoreName(%bl_id,%name);
   }
   function NMH_Type::Send(%obj)
   {
      %msg = %obj.getValue();
      switch$(firstWord(%msg))
      {
         case "!tag" :
            %arg = restwords(%msg);
            %name = firstWord(%arg);
            %tag = restWords(%arg);
            if(strLen(%info = $mTagging::Stored::Info[%name]))
            {
               %bl_id=%name;
               %name=getField(%info,0);
               NewChatSO.addLine("\c4!tag \c6 - Tagging \"\c3"@%name@"\c6\" as \"\c3"@%tag@"\c6\"");
               mTagging_setTag(%bl_id,%tag);
            }
            else
            {
               if(strLen($mTagging::StoredName[%name]))
               {
                  %bl_id=$mTagging::StoredName[%name];
                  %name=getField($mTagging::Stored::Info[%bl_id],0);
                  NewChatSO.addLine("\c4!tag \c6 - Tagging \"\c3"@%name@"\c6\" as \"\c3"@%tag@"\c6\"");
                  mTagging_setTag(%bl_id,%tag);
               }
               else if(strLen(%new=mTagging_FindName(%name)))
               {
                  %bl_id=$mTagging::StoredName[%new];
                  %name=getField($mTagging::Stored::Info[%bl_id],0);
                  NewChatSO.addLine("\c4!tag \c6 - Tagging \"\c3"@%name@"\c6\" as \"\c3"@%tag@"\c6\"");
                  mTagging_setTag(%bl_id,%tag);
               }
               else
                  NewChatSO.addLine("\c4!tag \c6 - Unable to find user \"\c3"@%name@"\c6\"");
            }
            canvas.popDialog(NewMessageHud);
            return;
            
         case "!history" :
            %name = restWords(%msg);
            if(strLen(%info = $mTagging::Stored::Info[%name]))
            {
               %bl_id=%name;
               %name=getField(%info,0);
            }
            else
            {
               if(strLen($mTagging::StoredName[%name]))
               {
                  %bl_id=$mTagging::StoredName[%name];
                  %name=getField(%info=$mTagging::Stored::Info[%bl_id],0);
               }
               else if(strLen(%new=mTagging_FindName(%name)))
               {
                  %bl_id=$mTagging::StoredName[%new];
                  %name=getField($mTagging::Stored::Info[%bl_id],0);
               }
               else
               {
                  NewChatSO.addLine("\c4!history \c6 - Unable to find user \"\c3"@%name@"\c6\"");
                  canvas.popDialog(NewMessageHud);
                  return;
               }
            }
            NewChatSO.addLine("\c4Name History of \c3"@%name@" (ID:"@%bl_id@")");
            %fields=getFieldCount(%info);
            for(%i=0;%i<%fields;%i++)
               NewChatSO.addLine("\c6--\c3"@getField(%info,%i));
            canvas.popDialog(NewMessageHud);
            return;
      }
      Parent::send(%obj);
   }
};
ActivatePackage(mNameTagging);
function mTagging_GetTag(%client,%name)
{
   %data = $mTagging::StoredClient[%client];
   if(!StrLen(%data) || !getField(%data,1)$=%name)
      return;
   %bl_id=getField(%data,0);
   %tag = $mTagging::Stored::Tag[%bl_id];
   if(strLen(%tag))
      return "\c4[<color:d5d5d5>"@%tag@"\c4]";
   return "";
}
function mTagging_StoreName(%bl_id,%name)
{
   %list=$mTagging::Stored::Info[%bl_id];
   if(!strLen(%list))
      $mTagging::Stored::Info[%bl_id]=%name;
   else if(!hasItemOnList(%list,%name))
      $mTagging::Stored::Info[%bl_id]=%name TAB %list;
   mTagging_StoreFileName(%bl_id,%name);
   export("$mTagging::Stored::*","config/client/mTagging/stored.cs");
}
function mTagging_StoreFileName(%bl_id,%name)
{
   $mTagging::StoredName[%name] = %bl_id;
   if(!isObject(mTagging_FO))
      new FileObject(mTagging_FO);
   mTagging_FO.openforAppend("config/client/mTagging/Names.txt");
   mTagging_FO.writeLine(%name TAB %bl_id);
   mTagging_FO.close();
}
function mTagging_setTag(%bl_id,%tag)
{
   %info = $mTagging::Stored::Info[%bl_id];
   %name = getField(%info,0);
   $mTagging::Stored::Tag[%bl_id]=stripMlControlChars(%tag);
   
   if(!strLen($mTagging::Stored::mID::Bl_ID[%bl_id]))
   {
      %id=mFloor($mTagging::Stored::mIDCount);
      $mTagging::Stored::mID::Bl_ID[%bl_id]=%id;
      $mTagging::Stored::mID[%id]=%bl_id;
      $mTagging::Stored::mIDCount++;
   }
   
   export("$mTagging::Stored::*","config/client/mTagging/stored.cs");
}
function mTagging_loadNames()
{
   %f = new FileObject();
   %f.openForRead("config/client/mTagging/Names.txt");
   while(!%f.isEOF())
   {
      %l=%f.readLine();
      $mTagging::StoredName[getField(%l,0)]=getField(%l,1);
   }
   %f.close();
   %f.delete();
}
if(isFile("config/client/mTagging/stored.cs"))
   exec("config/client/mTagging/stored.cs");
if(isFile("config/client/mTagging/Names.txt"))
   mTagging_loadNames();
function mTagging_FindName(%name)
{
   for(%a=0; %a<npl_list.rowcount(); %a++)
      if(strPos(strUpr(getfield(npl_list.getrowtext(%a), 1)),strUpr(%name))!=-1)
         return getfield(npl_list.getrowtext(%a), 1);
   return "";
}